"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CTranslator = void 0;
const Interpreter_1 = require("./Interpreter");
class CTranslator extends Interpreter_1.Interpreter {
    translate(statements) {
        return `
        #include <iostream>

        int main() {
            char band[30000];
            for (char &data : band)
            {
                data = 0;
            }
            char *pointer = band;
            ${this.interpret(statements).join(";")};
        }
    `;
    }
    loop({ value }) {
        return `
        while (*pointer != 0) {
            ${this.interpret(value).join(";")}
        }
    `;
    }
    change_value({ value }) {
        return `*pointer += ${value};`;
    }
    change_pointer({ value }) {
        return `pointer += ${value};`;
    }
    print() {
        return `std::cout << *pointer;`;
    }
    read() {
        return ` std::cin >> *pointer `;
    }
    zero_loop() {
        return `if (*pointer < 0) throw "Infinite zero loop detected!"; *pointer = 0;`;
    }
}
exports.CTranslator = CTranslator;
