"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectInterpreter = void 0;
const Interpreter_1 = require("./Interpreter");
class DirectInterpreter extends Interpreter_1.Interpreter {
    constructor(input) {
        super();
        this.input = input;
        this.band = [0];
        this.pointer = 0;
    }
    get currentValue() {
        return this.band[this.pointer];
    }
    set currentValue(value) {
        this.band[this.pointer] = value;
    }
    loop({ value }) {
        while (this.currentValue) {
            this.interpret(value);
        }
    }
    change_value({ value }) {
        this.currentValue = this.currentValue + value;
    }
    change_pointer({ value }) {
        this.pointer = this.pointer + value;
        if (this.currentValue === undefined)
            this.currentValue = 0;
    }
    print() {
        process.stdout.write(String.fromCharCode(this.currentValue));
    }
    read() {
        if (this.input.length < 1)
            throw new Error("Not enough input");
        this.currentValue = this.input[0];
        this.input = this.input.slice(1);
    }
    zero_loop() {
        if (this.currentValue < 0)
            throw new Error("Infinite zero loop detected!");
        this.currentValue = 0;
    }
}
exports.DirectInterpreter = DirectInterpreter;
